? gnu/usr.bin/perl/cpan/File-Path/t/Path-Class.t
? gnu/usr.bin/perl/dist/base/t/lib/BaseIncMandatory.pm
? gnu/usr.bin/perl/dist/base/t/lib/BaseIncOptional.pm
? gnu/usr.bin/perl/pod/perl5223delta.pod
? gnu/usr.bin/perl/pod/perl5224delta.pod
? gnu/usr.bin/perl/pod/perl5241delta.pod
? gnu/usr.bin/perl/pod/perl5242delta.pod
Index: gnu/usr.bin/perl/AUTHORS
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/AUTHORS,v
retrieving revision 1.3
diff -u -p -r1.3 AUTHORS
--- gnu/usr.bin/perl/AUTHORS	5 Feb 2017 00:31:51 -0000	1.3
+++ gnu/usr.bin/perl/AUTHORS	14 Sep 2017 02:21:28 -0000
@@ -298,6 +298,7 @@ Darrell Kindred			<dkindred+@cmu.edu>
 Darrell Schiebel		<drs@nrao.edu>
 Darren/Torin/Who Ever...	<torin@daft.com>
 Dave Bianchi
+Dave Cross			<dave@mag-sol.com>
 Dave Hartnoll			<Dave_Hartnoll@3b2.com>
 Dave Liney			<dave.liney@gbr.conoco.com>
 Dave Nelson			<David.Nelson@bellcow.com>
@@ -1147,6 +1148,7 @@ Steve Purkis			<Steve.Purkis@multimap.co
 Steve Vinoski
 Stevan Little			<stevan@cpan.org>
 Steven Hirsch			<hirschs@btv.ibm.com>
+Steven Humphrey			<catchperl@33k.co.uk>
 Steven Knight			<knight@theopera.baldmt.citilink.com>
 Steven Morlock			<newspost@morlock.net>
 Steven N. Hirsch		<hirschs@stargate.btv.ibm.com>
Index: gnu/usr.bin/perl/INSTALL
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/INSTALL,v
retrieving revision 1.20
diff -u -p -r1.20 INSTALL
--- gnu/usr.bin/perl/INSTALL	14 Aug 2017 13:48:45 -0000	1.20
+++ gnu/usr.bin/perl/INSTALL	14 Sep 2017 02:21:30 -0000
@@ -581,7 +581,7 @@ The directories set up by Configure fall
 
 =item Directories for the perl distribution
 
-By default, Configure will use the following directories for 5.24.2.
+By default, Configure will use the following directories for 5.24.3.
 $version is the full perl version number, including subversion, e.g.
 5.12.3, and $archname is a string like sun4-sunos,
 determined by Configure.  The full definitions of all Configure
@@ -2437,7 +2437,8 @@ http://www.chiark.greenend.org.uk/~sgtat
 
 =head1 Coexistence with earlier versions of perl 5
 
-Perl 5.24.2 is not binary compatible with earlier versions of Perl.
+Perl 5.24.3 is not binary compatible with versions of Perl earlier than
+5.24.0.
 In other words, you will have to recompile your XS modules.
 
 In general, you can usually safely upgrade from one version of Perl
@@ -2512,9 +2513,9 @@ won't interfere with another version.  (
 libraries after 5.6.0, but not for executables. TODO?)  One convenient
 way to do this is by using a separate prefix for each version, such as
 
-	sh Configure -Dprefix=/opt/perl5.24.2
+	sh Configure -Dprefix=/opt/perl5.24.3
 
-and adding /opt/perl5.24.2/bin to the shell PATH variable.  Such users
+and adding /opt/perl5.24.3/bin to the shell PATH variable.  Such users
 may also wish to add a symbolic link /usr/local/bin/perl so that
 scripts can still start with #!/usr/local/bin/perl.
 
@@ -2527,13 +2528,13 @@ seriously consider using a separate dire
 subversions may not have all the compatibility wrinkles ironed out
 yet.
 
-=head2 Upgrading from v5.22 or earlier
+=head2 Upgrading from 5.23.9 or earlier
 
-B<Perl 5.24.2 may not be binary compatible with Perl v5.22 or
+B<Perl 5.24.3 may not be binary compatible with Perl 5.23.9 or
 earlier Perl releases.>  Perl modules having binary parts
 (meaning that a C compiler is used) will have to be recompiled to be
-used with 5.24.2.  If you find you do need to rebuild an extension with
-5.24.2, you may safely do so without disturbing the older
+used with 5.24.3.  If you find you do need to rebuild an extension with
+5.24.3, you may safely do so without disturbing the older
 installations.  (See L<"Coexistence with earlier versions of perl 5">
 above.)
 
@@ -2566,15 +2567,15 @@ Firstly, the bare minimum to run this sc
      print("$f\n");
   }
 
-in Linux with perl-5.24.2 is as follows (under $Config{prefix}):
+in Linux with perl-5.24.3 is as follows (under $Config{prefix}):
 
   ./bin/perl
-  ./lib/perl5/5.24.2/strict.pm
-  ./lib/perl5/5.24.2/warnings.pm
-  ./lib/perl5/5.24.2/i686-linux/File/Glob.pm
-  ./lib/perl5/5.24.2/feature.pm
-  ./lib/perl5/5.24.2/XSLoader.pm
-  ./lib/perl5/5.24.2/i686-linux/auto/File/Glob/Glob.so
+  ./lib/perl5/5.24.3/strict.pm
+  ./lib/perl5/5.24.3/warnings.pm
+  ./lib/perl5/5.24.3/i686-linux/File/Glob.pm
+  ./lib/perl5/5.24.3/feature.pm
+  ./lib/perl5/5.24.3/XSLoader.pm
+  ./lib/perl5/5.24.3/i686-linux/auto/File/Glob/Glob.so
 
 Secondly, for perl-5.10.1, the Debian perl-base package contains 591
 files, (of which 510 are for lib/unicore) totaling about 3.5MB in its
Index: gnu/usr.bin/perl/MANIFEST
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/MANIFEST,v
retrieving revision 1.45
diff -u -p -r1.45 MANIFEST
--- gnu/usr.bin/perl/MANIFEST	14 Aug 2017 13:50:31 -0000	1.45
+++ gnu/usr.bin/perl/MANIFEST	14 Sep 2017 02:21:30 -0000
@@ -3576,6 +3576,7 @@ dist/Time-HiRes/t/time.t		Test for Time:
 dist/Time-HiRes/t/tv_interval.t		Test for Time::HiRes
 dist/Time-HiRes/t/ualarm.t		Test for Time::HiRes
 dist/Time-HiRes/t/usleep.t		Test for Time::HiRes
+dist/Time-HiRes/t/utime.t		Test for Time::HiRes
 dist/Time-HiRes/t/Watchdog.pm		Test for Time::HiRes
 dist/Time-HiRes/typemap			Time::HiRes extension
 dist/XSLoader/Makefile.PL	Dynamic Loader makefile writer
@@ -5127,8 +5128,10 @@ pod/perl5220delta.pod		Perl changes in v
 pod/perl5221delta.pod		Perl changes in version 5.22.1
 pod/perl5222delta.pod		Perl changes in version 5.22.2
 pod/perl5223delta.pod		Perl changes in version 5.22.3
+pod/perl5224delta.pod		Perl changes in version 5.22.4
 pod/perl5240delta.pod		Perl changes in version 5.24.0
 pod/perl5241delta.pod		Perl changes in version 5.24.1
+pod/perl5242delta.pod		Perl changes in version 5.24.2
 pod/perl561delta.pod		Perl changes in version 5.6.1
 pod/perl56delta.pod		Perl changes in version 5.6
 pod/perl581delta.pod		Perl changes in version 5.8.1
Index: gnu/usr.bin/perl/Makefile.SH
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/Makefile.SH,v
retrieving revision 1.39
diff -u -p -r1.39 Makefile.SH
--- gnu/usr.bin/perl/Makefile.SH	14 Aug 2017 13:50:31 -0000	1.39
+++ gnu/usr.bin/perl/Makefile.SH	14 Sep 2017 02:21:30 -0000
@@ -522,7 +522,7 @@ miniperl_objs = $(miniperl_objs_nodt) $(
 perllib_objs  = $(perllib_objs_nodt) $(DTRACE_PERLLIB_O)
 perlmain_objs = perlmain$(OBJ_EXT) $(DTRACE_MAIN_O)
 
-perltoc_pod_prereqs = extra.pods pod/perl5242delta.pod pod/perlapi.pod pod/perlintern.pod pod/perlmodlib.pod
+perltoc_pod_prereqs = extra.pods pod/perl5243delta.pod pod/perlapi.pod pod/perlintern.pod pod/perlmodlib.pod
 generated_pods = pod/perltoc.pod $(perltoc_pod_prereqs)
 generated_headers = uudmap.h bitcount.h mg_data.h
 
@@ -1079,9 +1079,9 @@ pod/perlintern.pod: $(MINIPERL_EXE) auto
 pod/perlmodlib.pod: $(MINIPERL_EXE) pod/perlmodlib.PL MANIFEST
 	$(MINIPERL) pod/perlmodlib.PL -q
 
-pod/perl5242delta.pod: pod/perldelta.pod
-	$(RMS) pod/perl5242delta.pod
-	$(LNS) perldelta.pod pod/perl5242delta.pod
+pod/perl5243delta.pod: pod/perldelta.pod
+	$(RMS) pod/perl5243delta.pod
+	$(LNS) perldelta.pod pod/perl5243delta.pod
 
 extra.pods: $(MINIPERL_EXE)
 	-@test ! -f extra.pods || rm -f `cat extra.pods`
Index: gnu/usr.bin/perl/README.haiku
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/README.haiku,v
retrieving revision 1.4
diff -u -p -r1.4 README.haiku
--- gnu/usr.bin/perl/README.haiku	14 Aug 2017 13:48:45 -0000	1.4
+++ gnu/usr.bin/perl/README.haiku	14 Sep 2017 02:21:31 -0000
@@ -22,9 +22,9 @@ The build procedure is completely standa
 Make perl executable and create a symlink for libperl:
 
   chmod a+x /boot/common/bin/perl
-  cd /boot/common/lib; ln -s perl5/5.24.2/BePC-haiku/CORE/libperl.so .
+  cd /boot/common/lib; ln -s perl5/5.24.3/BePC-haiku/CORE/libperl.so .
 
-Replace C<5.24.2> with your respective version of Perl.
+Replace C<5.24.3> with your respective version of Perl.
 
 =head1 KNOWN PROBLEMS
 
Index: gnu/usr.bin/perl/README.macosx
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/README.macosx,v
retrieving revision 1.4
diff -u -p -r1.4 README.macosx
--- gnu/usr.bin/perl/README.macosx	14 Aug 2017 13:48:45 -0000	1.4
+++ gnu/usr.bin/perl/README.macosx	14 Sep 2017 02:21:31 -0000
@@ -10,9 +10,9 @@ perlmacosx - Perl under Mac OS X
 
 This document briefly describes Perl under Mac OS X.
 
-  curl -O http://www.cpan.org/src/perl-5.24.2.tar.gz
-  tar -xzf perl-5.24.2.tar.gz
-  cd perl-5.24.2
+  curl -O http://www.cpan.org/src/perl-5.24.3.tar.gz
+  tar -xzf perl-5.24.3.tar.gz
+  cd perl-5.24.3
   ./Configure -des -Dprefix=/usr/local/
   make
   make test
@@ -20,7 +20,7 @@ This document briefly describes Perl und
 
 =head1 DESCRIPTION
 
-The latest Perl release (5.24.2 as of this writing) builds without changes
+The latest Perl release (5.24.3 as of this writing) builds without changes
 under all versions of Mac OS X from 10.3 "Panther" onwards. 
 
 In order to build your own version of Perl you will need 'make',
Index: gnu/usr.bin/perl/README.os2
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/README.os2,v
retrieving revision 1.20
diff -u -p -r1.20 README.os2
--- gnu/usr.bin/perl/README.os2	14 Aug 2017 13:48:45 -0000	1.20
+++ gnu/usr.bin/perl/README.os2	14 Sep 2017 02:21:31 -0000
@@ -619,7 +619,7 @@ C<set PERLLIB_PREFIX> in F<Config.sys>, 
 
 =item Additional Perl modules
 
-  unzip perl_ste.zip -d f:/perllib/lib/site_perl/5.24.2/
+  unzip perl_ste.zip -d f:/perllib/lib/site_perl/5.24.3/
 
 Same remark as above applies.  Additionally, if this directory is not
 one of directories on @INC (and @INC is influenced by C<PERLLIB_PREFIX>), you
Index: gnu/usr.bin/perl/README.vms
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/README.vms,v
retrieving revision 1.21
diff -u -p -r1.21 README.vms
--- gnu/usr.bin/perl/README.vms	14 Aug 2017 13:48:45 -0000	1.21
+++ gnu/usr.bin/perl/README.vms	14 Sep 2017 02:21:31 -0000
@@ -142,11 +142,11 @@ You may need to set up a foreign symbol 
 choice.  Once you have done so, use a command like the following to
 unpack the archive:
 
-    vmstar -xvf perl-5^.24^.2.tar
+    vmstar -xvf perl-5^.24^.3.tar
 
 Then set default to the top-level source directory like so:
 
-    set default [.perl-5^.24^.2]
+    set default [.perl-5^.24^.3]
 
 and proceed with configuration as described in the next section.
 
Index: gnu/usr.bin/perl/configure.com
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/configure.com,v
retrieving revision 1.5
diff -u -p -r1.5 configure.com
--- gnu/usr.bin/perl/configure.com	5 Feb 2017 00:31:52 -0000	1.5
+++ gnu/usr.bin/perl/configure.com	14 Sep 2017 02:21:33 -0000
@@ -1354,7 +1354,8 @@ $     vms_cc_available = vms_cc_availabl
 $   ENDIF
 $ ELSE
 $   IF (F$LOCATE("DEC",line).NE.F$LENGTH(line)).or.(F$LOCATE("Compaq",line).NE.F$LENGTH(line)) -
-    .or.(F$LOCATE("HP",F$EDIT(line,"UPCASE")).NE.F$LENGTH(line))
+    .or.(F$LOCATE("HP",F$EDIT(line,"UPCASE")).NE.F$LENGTH(line)) -
+    .or.(F$LOCATE("VSI",F$EDIT(line,"UPCASE")).NE.F$LENGTH(line))
 $   THEN 
 $     vms_cc_dflt = "/decc"
 $     vms_cc_available = vms_cc_available + "cc/decc "
@@ -1491,7 +1492,8 @@ $ THEN
 $   ans = F$EDIT(ans,"TRIM, COMPRESS, LOWERCASE")
 $   Mcc = ans
 $   IF (F$LOCATE("dec",ans).NE.F$LENGTH(ans)).or.(F$LOCATE("compaq",ans).NE.F$LENGTH(ans)) -
-    .or.(F$LOCATE("hp",ans).NE.F$LENGTH(ans))
+    .or.(F$LOCATE("hp",ans).NE.F$LENGTH(ans)) -
+    .or.(F$LOCATE("vsi",ans).NE.F$LENGTH(ans))
 $   THEN
 $     Mcc = "cc/decc"
 $! CPQ ?
@@ -1508,7 +1510,8 @@ $   ELSE ! Not_cxx
 $     IF Mcc.NES.dflt
 $     THEN
 $       IF F$LOCATE("dec",dflt) .NE. F$LENGTH(dflt) .or. -
-           F$LOCATE("compaq",dflt) .NE. F$LENGTH(dflt)
+           F$LOCATE("compaq",dflt) .NE. F$LENGTH(dflt) -
+          .or.(F$LOCATE("vsi",dflt).NE.F$LENGTH(dflt))
 $       THEN 
 $         C_COMPILER_Replace = "CC=cc=''Mcc'"
 $       ELSE
Index: gnu/usr.bin/perl/doio.c
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/doio.c,v
retrieving revision 1.19
diff -u -p -r1.19 doio.c
--- gnu/usr.bin/perl/doio.c	5 Feb 2017 00:31:52 -0000	1.19
+++ gnu/usr.bin/perl/doio.c	14 Sep 2017 02:21:34 -0000
@@ -1845,18 +1845,8 @@ Perl_apply(pTHX_ I32 type, SV **mark, SV
                         int fd = PerlIO_fileno(IoIFP(GvIOn(gv)));
 			APPLY_TAINT_PROPER();
                         if (fd < 0) {
-			    SETERRNO(EBADF,RMS_IFI);
+                            SETERRNO(EBADF,RMS_IFI);
 			    tot--;
-#if Uid_t_sign == 1
-			} else if (val < 0) {
-			    SETERRNO(EINVAL,LIB_INVARG);
-			    tot--;
-#endif
-#if Gid_t_sign == 1
-			} else if (val2 < 0) {
-			    SETERRNO(EINVAL,LIB_INVARG);
-			    tot--;
-#endif
                         } else if (fchown(fd, val, val2))
 			    tot--;
 #else
Index: gnu/usr.bin/perl/embed.fnc
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/embed.fnc,v
retrieving revision 1.4
diff -u -p -r1.4 embed.fnc
--- gnu/usr.bin/perl/embed.fnc	14 Aug 2017 13:48:45 -0000	1.4
+++ gnu/usr.bin/perl/embed.fnc	14 Sep 2017 02:21:34 -0000
@@ -2113,7 +2113,7 @@ s	|OP*	|doform		|NN CV *cv|NN GV *gv|NUL
 #  if !defined(HAS_MKDIR) || !defined(HAS_RMDIR)
 sR	|int	|dooneliner	|NN const char *cmd|NN const char *filename
 #  endif
-s	|SV *	|space_join_names_mortal|NN char *const *array
+s	|SV *	|space_join_names_mortal|NULLOK char *const *array
 #endif
 p	|OP *	|tied_method|NN SV *methname|NN SV **sp \
 				|NN SV *const sv|NN const MAGIC *const mg \
@@ -2282,7 +2282,8 @@ Es	|bool	|put_charclass_bitmap_innards|N
 				|NN char* bitmap		    \
 				|NULLOK SV* nonbitmap_invlist	    \
 				|NULLOK SV* only_utf8_locale_invlist\
-				|NULLOK const regnode * const node
+				|NULLOK const regnode * const node  \
+				|const bool force_as_is_display
 Es	|SV*	|put_charclass_bitmap_innards_common		    \
 				|NN SV* invlist			    \
 				|NULLOK SV* posixes		    \
Index: gnu/usr.bin/perl/embed.h
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/embed.h,v
retrieving revision 1.20
diff -u -p -r1.20 embed.h
--- gnu/usr.bin/perl/embed.h	14 Aug 2017 13:48:45 -0000	1.20
+++ gnu/usr.bin/perl/embed.h	14 Sep 2017 02:21:34 -0000
@@ -964,7 +964,7 @@
 #define dump_trie_interim_list(a,b,c,d,e)	S_dump_trie_interim_list(aTHX_ a,b,c,d,e)
 #define dump_trie_interim_table(a,b,c,d,e)	S_dump_trie_interim_table(aTHX_ a,b,c,d,e)
 #define dumpuntil(a,b,c,d,e,f,g,h)	S_dumpuntil(aTHX_ a,b,c,d,e,f,g,h)
-#define put_charclass_bitmap_innards(a,b,c,d,e)	S_put_charclass_bitmap_innards(aTHX_ a,b,c,d,e)
+#define put_charclass_bitmap_innards(a,b,c,d,e,f)	S_put_charclass_bitmap_innards(aTHX_ a,b,c,d,e,f)
 #define put_charclass_bitmap_innards_common(a,b,c,d,e,f)	S_put_charclass_bitmap_innards_common(aTHX_ a,b,c,d,e,f)
 #define put_charclass_bitmap_innards_invlist(a,b)	S_put_charclass_bitmap_innards_invlist(aTHX_ a,b)
 #define put_code_point(a,b)	S_put_code_point(aTHX_ a,b)
Index: gnu/usr.bin/perl/hv.c
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/hv.c,v
retrieving revision 1.21
diff -u -p -r1.21 hv.c
--- gnu/usr.bin/perl/hv.c	5 Feb 2017 00:31:52 -0000	1.21
+++ gnu/usr.bin/perl/hv.c	14 Sep 2017 02:21:35 -0000
@@ -2476,9 +2476,10 @@ Perl_hv_ename_delete(pTHX_ HV *hv, const
 		return;
 	    }
 	if (
-	    count > 0 && (HEK_UTF8(*namep) || (flags & SVf_UTF8)) 
+	    count > 0 && ((HEK_UTF8(*namep) || (flags & SVf_UTF8)) 
                 ? hek_eq_pvn_flags(aTHX_ *namep, name, (I32)len, flags)
 	        : (HEK_LEN(*namep) == (I32)len && memEQ(HEK_KEY(*namep), name, len))
+            )
 	) {
 	    aux->xhv_name_count = -count;
 	}
Index: gnu/usr.bin/perl/locale.c
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/locale.c,v
retrieving revision 1.3
diff -u -p -r1.3 locale.c
--- gnu/usr.bin/perl/locale.c	5 Feb 2017 00:31:52 -0000	1.3
+++ gnu/usr.bin/perl/locale.c	14 Sep 2017 02:21:36 -0000
@@ -836,7 +836,7 @@ Perl_init_i18nl10n(pTHX_ int printwarn)
                        : NULL;
 	sl_result = my_setlocale(LC_MESSAGES, locale_param);
         DEBUG_LOCALE_INIT(LC_MESSAGES, locale_param, sl_result);
-	if (! sl_result)
+	if (! sl_result) {
 	    setlocale_failure = TRUE;
         }
 #       endif /* USE_LOCALE_MESSAGES */
Index: gnu/usr.bin/perl/op.c
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/op.c,v
retrieving revision 1.21
diff -u -p -r1.21 op.c
--- gnu/usr.bin/perl/op.c	5 Feb 2017 00:31:53 -0000	1.21
+++ gnu/usr.bin/perl/op.c	14 Sep 2017 02:21:37 -0000
@@ -3223,6 +3223,12 @@ S_scalar_mod_type(const OP *o, I32 type)
     case OP_BIT_AND:
     case OP_BIT_XOR:
     case OP_BIT_OR:
+    case OP_NBIT_AND:
+    case OP_NBIT_XOR:
+    case OP_NBIT_OR:
+    case OP_SBIT_AND:
+    case OP_SBIT_XOR:
+    case OP_SBIT_OR:
     case OP_CONCAT:
     case OP_SUBST:
     case OP_TRANS:
@@ -6747,24 +6753,7 @@ S_new_logop(pTHX_ I32 type, I32 flags, O
 	|| type == OP_CUSTOM);
 
     scalarboolean(first);
-    /* optimize AND and OR ops that have NOTs as children */
-    if (first->op_type == OP_NOT
-	&& (first->op_flags & OPf_KIDS)
-	&& ((first->op_flags & OPf_SPECIAL) /* unless ($x) { } */
-	    || (other->op_type == OP_NOT))  /* if (!$x && !$y) { } */
-	) {
-	if (type == OP_AND || type == OP_OR) {
-	    if (type == OP_AND)
-		type = OP_OR;
-	    else
-		type = OP_AND;
-	    op_null(first);
-	    if (other->op_type == OP_NOT) { /* !a AND|OR !b => !(a OR|AND b) */
-		op_null(other);
-		prepend_not = 1; /* prepend a NOT op later */
-	    }
-	}
-    }
+
     /* search for a constant op that could let us fold the test */
     if ((cstop = search_const(first))) {
 	if (cstop->op_private & OPpCONST_STRICT)
@@ -6863,6 +6852,25 @@ S_new_logop(pTHX_ I32 type, I32 flags, O
 
     if (type == OP_ANDASSIGN || type == OP_ORASSIGN || type == OP_DORASSIGN)
 	other->op_private |= OPpASSIGN_BACKWARDS;  /* other is an OP_SASSIGN */
+
+    /* optimize AND and OR ops that have NOTs as children */
+    if (first->op_type == OP_NOT
+        && (first->op_flags & OPf_KIDS)
+        && ((first->op_flags & OPf_SPECIAL) /* unless ($x) { } */
+            || (other->op_type == OP_NOT))  /* if (!$x && !$y) { } */
+        ) {
+        if (type == OP_AND || type == OP_OR) {
+            if (type == OP_AND)
+                type = OP_OR;
+            else
+                type = OP_AND;
+            op_null(first);
+            if (other->op_type == OP_NOT) { /* !a AND|OR !b => !(a OR|AND b) */
+                op_null(other);
+                prepend_not = 1; /* prepend a NOT op later */
+            }
+        }
+    }
 
     logop = S_alloc_LOGOP(aTHX_ type, first, LINKLIST(other));
     logop->op_flags |= (U8)flags;
Index: gnu/usr.bin/perl/opcode.h
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/opcode.h,v
retrieving revision 1.17
diff -u -p -r1.17 opcode.h
--- gnu/usr.bin/perl/opcode.h	5 Feb 2017 00:31:53 -0000	1.17
+++ gnu/usr.bin/perl/opcode.h	14 Sep 2017 02:21:37 -0000
@@ -642,12 +642,12 @@ EXTCONST char* const PL_op_desc[] = {
 	"bitwise and (&)",
 	"bitwise xor (^)",
 	"bitwise or (|)",
-	"numeric bitiwse and (&)",
+	"numeric bitwise and (&)",
 	"numeric bitwise xor (^)",
 	"numeric bitwise or (|)",
-	"string bitiwse and (&)",
-	"string bitwise xor (^)",
-	"string bitwise or (|)",
+	"string bitwise and (&.)",
+	"string bitwise xor (^.)",
+	"string bitwise or (|.)",
 	"negation (-)",
 	"integer negation (-)",
 	"not",
Index: gnu/usr.bin/perl/patchlevel.h
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/patchlevel.h,v
retrieving revision 1.44
diff -u -p -r1.44 patchlevel.h
--- gnu/usr.bin/perl/patchlevel.h	14 Aug 2017 13:48:45 -0000	1.44
+++ gnu/usr.bin/perl/patchlevel.h	14 Sep 2017 02:21:38 -0000
@@ -15,7 +15,7 @@
 
 #define PERL_REVISION	5		/* age */
 #define PERL_VERSION	24		/* epoch */
-#define PERL_SUBVERSION	2		/* generation */
+#define PERL_SUBVERSION	3		/* generation */
 
 /* The following numbers describe the earliest compatible version of
    Perl ("compatibility" here being defined as sufficient binary/API
@@ -133,6 +133,7 @@ hunk.
 #  endif
 static const char * const local_patches[] = {
 	NULL
+	,"RC1"
 #ifdef PERL_GIT_UNCOMMITTED_CHANGES
 	,"uncommitted-changes"
 #endif
Index: gnu/usr.bin/perl/perl.h
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/perl.h,v
retrieving revision 1.21
diff -u -p -r1.21 perl.h
--- gnu/usr.bin/perl/perl.h	5 Feb 2017 00:31:53 -0000	1.21
+++ gnu/usr.bin/perl/perl.h	14 Sep 2017 02:21:38 -0000
@@ -2022,6 +2022,12 @@ extern long double Perl_my_frexpl(long d
 #   define Perl_isinf(x) isinfq(x)
 #   define Perl_isnan(x) isnanq(x)
 #   define Perl_isfinite(x) !(isnanq(x) || isinfq(x))
+#   define Perl_fp_class(x) ((x) == 0.0Q ? 0 : isinfq(x) ? 3 : isnanq(x) ? 4 : PERL_ABS(x) < FLT128_MIN ? 2 : 1)
+#   define Perl_fp_class_inf(x)    (Perl_fp_class(x) == 3)
+#   define Perl_fp_class_nan(x)    (Perl_fp_class(x) == 4)
+#   define Perl_fp_class_norm(x)   (Perl_fp_class(x) == 1)
+#   define Perl_fp_class_denorm(x) (Perl_fp_class(x) == 2)
+#   define Perl_fp_class_zero(x)   (Perl_fp_class(x) == 0)
 #else
 #   define NV_DIG DBL_DIG
 #   ifdef DBL_MANT_DIG
@@ -3064,6 +3070,8 @@ freeing any remaining Perl interpreters.
  */
 #if defined(USE_ITHREADS) && defined(I_PTHREAD) && \
     defined(__clang__) && \
+    !defined(PERL_GLOBAL_STRUCT) && \
+    !defined(PERL_GLOBAL_STRUCT_PRIVATE) && \
     !defined(SWIG) && \
   ((!defined(__apple_build_version__) &&               \
     ((__clang_major__ == 3 && __clang_minor__ >= 6) || \
@@ -6304,7 +6312,7 @@ expression, but with an empty argument l
 #    ifdef __hpux
 #        define strtoll __strtoll	/* secret handshake */
 #    endif
-#    ifdef WIN64
+#    if defined(WIN64) && defined(_MSC_VER)
 #        define strtoll _strtoi64	/* secret handshake */
 #    endif
 #   if !defined(Strtol) && defined(HAS_STRTOLL)
@@ -6338,7 +6346,7 @@ expression, but with an empty argument l
 #    ifdef __hpux
 #        define strtoull __strtoull	/* secret handshake */
 #    endif
-#    ifdef WIN64
+#    if defined(WIN64) && defined(_MSC_VER)
 #        define strtoull _strtoui64	/* secret handshake */
 #    endif
 #    if !defined(Strtoul) && defined(HAS_STRTOULL)
@@ -6756,7 +6764,9 @@ extern void moncontrol(int);
 #endif
 
 /* All the basic IEEE formats have the implicit bit,
- * except for the 80-bit extended formats, which will undef this. */
+ * except for the x86 80-bit extended formats, which will undef this.
+ * Also note that the IEEE 754 subnormals (formerly known as denormals)
+ * do not have the implicit bit of one. */
 #define NV_IMPLICIT_BIT
 
 #ifdef LONG_DOUBLEKIND
@@ -6783,6 +6793,7 @@ extern void moncontrol(int);
 #    define LONGDOUBLE_X86_80_BIT
 #    ifdef USE_LONG_DOUBLE
 #      undef NV_IMPLICIT_BIT
+#      define NV_X86_80_BIT
 #    endif
 #  endif
 
Index: gnu/usr.bin/perl/pp_ctl.c
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pp_ctl.c,v
retrieving revision 1.19
diff -u -p -r1.19 pp_ctl.c
--- gnu/usr.bin/perl/pp_ctl.c	5 Feb 2017 00:31:53 -0000	1.19
+++ gnu/usr.bin/perl/pp_ctl.c	14 Sep 2017 02:21:39 -0000
@@ -3678,8 +3678,8 @@ PP(pp_require)
 
     if (!IS_SAFE_PATHNAME(name, len, "require")) {
         DIE(aTHX_ "Can't locate %s:   %s",
-            pv_escape(newSVpvs_flags("",SVs_TEMP),SvPVX(sv),SvCUR(sv),
-                      SvCUR(sv)*2,NULL, SvUTF8(sv)?PERL_PV_ESCAPE_UNI:0),
+            pv_escape(newSVpvs_flags("",SVs_TEMP),name,len,len*2,
+                      NULL, SvUTF8(sv)?PERL_PV_ESCAPE_UNI:0),
             Strerror(ENOENT));
     }
     TAINT_PROPER("require");
Index: gnu/usr.bin/perl/pp_hot.c
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pp_hot.c,v
retrieving revision 1.18
diff -u -p -r1.18 pp_hot.c
--- gnu/usr.bin/perl/pp_hot.c	5 Feb 2017 00:31:53 -0000	1.18
+++ gnu/usr.bin/perl/pp_hot.c	14 Sep 2017 02:21:39 -0000
@@ -1181,6 +1181,7 @@ S_aassign_copy_common(pTHX_ SV **firstle
         assert(svr);
 
         if (UNLIKELY(SvFLAGS(svr) & (SVf_BREAK|SVs_GMG) || copy_all)) {
+            U32 brk = (SvFLAGS(svr) & SVf_BREAK);
 
 #ifdef DEBUGGING
             if (fake) {
@@ -1216,7 +1217,7 @@ S_aassign_copy_common(pTHX_ SV **firstle
             /* ... but restore afterwards in case it's needed again,
              * e.g. ($a,$b,$c) = (1,$a,$a)
              */
-            SvFLAGS(svr) |= SVf_BREAK;
+            SvFLAGS(svr) |= brk;
         }
 
         if (!lcount)
Index: gnu/usr.bin/perl/pp_sys.c
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pp_sys.c,v
retrieving revision 1.19
diff -u -p -r1.19 pp_sys.c
--- gnu/usr.bin/perl/pp_sys.c	5 Feb 2017 00:31:53 -0000	1.19
+++ gnu/usr.bin/perl/pp_sys.c	14 Sep 2017 02:21:40 -0000
@@ -2497,7 +2497,6 @@ PP(pp_socket)
     TAINT_PROPER("socket");
     fd = PerlSock_socket(domain, type, protocol);
     if (fd < 0) {
-        SETERRNO(EBADF,RMS_IFI);
 	RETPUSHUNDEF;
     }
     IoIFP(io) = PerlIO_fdopen(fd, "r"SOCKET_OPEN_MODE);	/* stdio gets confused about sockets */
@@ -3531,8 +3530,9 @@ PP(pp_fttext)
         }
 	PL_laststatval = PerlLIO_fstat(fd, &PL_statcache);
 	if (PL_laststatval < 0)	{
+            dSAVE_ERRNO;
 	    (void)PerlIO_close(fp);
-            SETERRNO(EBADF,RMS_IFI);
+            RESTORE_ERRNO;
 	    FT_RETURNUNDEF;
 	}
 	PerlIO_binmode(aTHX_ fp, '<', O_BINARY, NULL);
@@ -4934,9 +4934,7 @@ S_space_join_names_mortal(pTHX_ char *co
 {
     SV *target;
 
-    PERL_ARGS_ASSERT_SPACE_JOIN_NAMES_MORTAL;
-
-    if (*array) {
+    if (array && *array) {
 	target = newSVpvs_flags("", SVs_TEMP);
 	while (1) {
 	    sv_catpv(target, *array);
Index: gnu/usr.bin/perl/proto.h
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/proto.h,v
retrieving revision 1.20
diff -u -p -r1.20 proto.h
--- gnu/usr.bin/perl/proto.h	14 Aug 2017 13:48:45 -0000	1.20
+++ gnu/usr.bin/perl/proto.h	14 Sep 2017 02:21:40 -0000
@@ -3842,7 +3842,7 @@ STATIC void	S_dump_trie_interim_table(pT
 STATIC const regnode*	S_dumpuntil(pTHX_ const regexp *r, const regnode *start, const regnode *node, const regnode *last, const regnode *plast, SV* sv, I32 indent, U32 depth);
 #define PERL_ARGS_ASSERT_DUMPUNTIL	\
 	assert(r); assert(start); assert(node); assert(sv)
-STATIC bool	S_put_charclass_bitmap_innards(pTHX_ SV* sv, char* bitmap, SV* nonbitmap_invlist, SV* only_utf8_locale_invlist, const regnode * const node);
+STATIC bool	S_put_charclass_bitmap_innards(pTHX_ SV* sv, char* bitmap, SV* nonbitmap_invlist, SV* only_utf8_locale_invlist, const regnode * const node, const bool force_as_is_display);
 #define PERL_ARGS_ASSERT_PUT_CHARCLASS_BITMAP_INNARDS	\
 	assert(sv); assert(bitmap)
 STATIC SV*	S_put_charclass_bitmap_innards_common(pTHX_ SV* invlist, SV* posixes, SV* only_utf8, SV* not_utf8, SV* only_utf8_locale, const bool invert);
@@ -4693,8 +4693,6 @@ STATIC OP*	S_doform(pTHX_ CV *cv, GV *gv
 #define PERL_ARGS_ASSERT_DOFORM	\
 	assert(cv); assert(gv)
 STATIC SV *	S_space_join_names_mortal(pTHX_ char *const *array);
-#define PERL_ARGS_ASSERT_SPACE_JOIN_NAMES_MORTAL	\
-	assert(array)
 #endif
 #if defined(PERL_IN_REGCOMP_C)
 STATIC void	S__append_range_to_invlist(pTHX_ SV* const invlist, const UV start, const UV end);
